// Complete testing of Tarray class

#include <iostream.h>
#include "tarray.h"

int main (void)
   {
   cout << "\n\nVerifying Tarray class operation...\n";

   int i, siz;

   // The array to test
   Tarray<double> a;

   // Making sure we start with an empty array
   cout << "Verifying initial size\n";

   siz = a.size();
   if(siz==0) cout << "Initial size verified\n";
   else cout << "Failure in initial size check!\n";

   // Resizing and checking
   cout << "Resizing to 10\n";

   a.resize(10);
   for(i=0;i<a.size();i++) a[i] = i;

   // Making sure we have the correct size now
   cout << "Verifying resize\n";

   siz = a.size();
   if(siz==10) cout << "Resize verified\n";
   else cout << "Failure in resize check!\n";

   // Lets try printing everything out with the for_each
   cout << "Verifying each element by printing, you should see number 0 to 9\n";

   for(i=0;i<a.size();i++) cout << a[i] << ",";
   cout << endl;

   // Lets try removing the last element
   cout << "Lets resizing to remove the last element and print again\n";

   a.resize(9);
   for(i=0;i<a.size();i++) cout << a[i] << ",";
   cout << endl;

   // Lets look at some elements with operator[]
   cout << "Lets look at some elements with operator[]\n";

   cout << "a[1] is " << a[1] << endl;

   // Lets modify some elements with operator[]
   cout << "Lets modify some elements with operator[]\n";
   cout << "Setting a[1] to -1.0" << endl;

   a[1] = -1.0;
   cout << "a[1] is now " << a[1] << endl;
   }


