//----------------------------------------------------------------------------
//
// DETL - A template library 1.0 beta
//
// Douglas Eleveld (D.J.Eleveld@anest.azg.nl)
//
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Templated queue class
//----------------------------------------------------------------------------
#ifndef TEMPLATE_QUEUE
#define TEMPLATE_QUEUE

//----------------------------------------------------------------------------
#include "detl.h"
#include "tdllist.h"

//----------------------------------------------------------------------------
// Templated queue
template <class T> class Tqueue
      :public Tdouble_link_list<T>
      {
      private:

      public:
            // Constructors and destructors
            Tqueue (void)          { };
            virtual ~Tqueue (void) { };

            // Basic queue manipulation
            inline void enqueue (const T& item) { append(item);    };
            inline void dequeue (void)          { remove(first()); };
            inline T*   front   (void)          { if(is_empty()==false) return &(first().node); else return NULL; };
      };

//----------------------------------------------------------------------------
#endif

